#include "EnumNamedCounterDataImpl.h"

#include <iostream>
using std::cout;
using std::endl;

#pragma warning(disable : 4786)  // identifier was truncated to '255' characters in the debug information

const size_t EnumNamedCounterDataEvictorTraits::maxServants = 10;
const size_t EnumNamedCounterDataEvictorTraits::timeout = 5;

EnumNamedCounterDataImpl::EnumNamedCounterDataImpl(
   NamedCounterFactoryImpl::CounterContainer &counters)
	:	RefCountedBase("EnumNamedCounterDataImpl"),
      m_counters(counters),
      m_current(counters.beginList())
{ 
	cout << "EnumNamedCounterDataImpl::EnumNamedCounterDataImpl() - " << this <<   endl; 
}

void EnumNamedCounterDataImpl::SetCurrent(NamedCounterFactoryImpl::CounterContainer::list_iterator &current) 
{
   m_current = current;
}

EnumNamedCounterDataImpl::~EnumNamedCounterDataImpl() 
{ 
	cout << "EnumNamedCounterDataImpl::~EnumNamedCounterDataImpl() - " << this << endl; 
}

CORBA::Long EnumNamedCounterDataImpl::Next(
   CORBA::ULong maxCounters, 
   counterDataSeq& theCounters)
{
	cout << "EnumNamedCounterDataImpl::Next() - " << maxCounters;

	long numCounters = 0;

   theCounters.length(maxCounters);

   while (m_current != m_counters.endList() && 
          numCounters < maxCounters)
   {
      struct CounterData data;

      data.name = (*m_current)->name();
      data.value = (*m_current)->value();

      theCounters[numCounters] = data;
	   ++m_current;
      ++numCounters;
   }

   theCounters.length(numCounters);

   return numCounters;
}

CORBA::Boolean EnumNamedCounterDataImpl::Skip(CORBA::ULong numToSkip)
{
	cout << "EnumNamedCounterDataImpl::Skip() - " << numToSkip << endl;

	CORBA::ULong numSkipped = 0;

   while (m_current != m_counters.endList() && 
          numSkipped != numToSkip)
   {
      ++m_current;
      ++numSkipped;
   }

   return (numSkipped == numToSkip);
}

void EnumNamedCounterDataImpl::Reset()
{
	cout << "EnumNamedCounterDataImpl::Reset()" << endl;

	m_current = m_counters.beginList();
}

EnumNamedCounterData_ptr EnumNamedCounterDataImpl::Clone()
{
	cout << "EnumNamedCounterDataImpl::Clone()" << endl;

	EnumNamedCounterDataImpl *pCopy = new EnumNamedCounterDataImpl(m_counters);
	
	pCopy->SetCurrent(m_current);

	return pCopy->_this();
}
