#ifndef NAMED_COUNTER_DATA_ITERATOR_IMPL_INCLUDED__
#define NAMED_COUNTER_DATA_ITERATOR_IMPL_INCLUDED__

#include "NamedCounterFactory.h"

#include "TEvictorBase.h"

#include "refcount.h"

struct NamedCounterDataIteratorEvictorTraits
{
   static const size_t maxServants;
   static const size_t timeout;
};

class NamedCounterDataIteratorImpl : 
   public TEvictor<
      POA_NamedCounterDataIterator,
      NamedCounterDataIterator, 
      NamedCounterDataIterator_ptr,
      NamedCounterDataIteratorEvictorTraits>
{
	public:
		
      NamedCounterDataIteratorImpl(
         NamedCounterFactoryImpl::CounterContainer &counters);
      
      virtual ~NamedCounterDataIteratorImpl();

      CORBA::Boolean next_n(
         CORBA::ULong how_many, 
		   counterDataSeq_out theCounters);
	
	   void destroy();
		
      bool AtEnd();

   private :

      NamedCounterFactoryImpl::CounterContainer &m_counters;
      NamedCounterFactoryImpl::CounterContainer::list_iterator m_current;
};


#endif // NAMED_COUNTER_DATA_ITERATOR_IMPL_INCLUDED__