#ifndef NAMED_COUNTER_ITERATOR_IMPL_INCLUDED__
#define NAMED_COUNTER_ITERATOR_IMPL_INCLUDED__

#include "NamedCounterFactory.h"

#include "TEvictorBase.h"

#include "refcount.h"

struct NamedCounterIteratorEvictorTraits
{
   static const size_t maxServants;
   static const size_t timeout;
};

class NamedCounterIteratorImpl : 
   public TEvictor<
      POA_NamedCounterIterator,
      NamedCounterIterator, 
      NamedCounterIterator_ptr,
      NamedCounterIteratorEvictorTraits>
{
	public:
		
      NamedCounterIteratorImpl(
         NamedCounterFactoryImpl::CounterContainer &counters);
      
      virtual ~NamedCounterIteratorImpl();

      CORBA::Boolean next_n(
         CORBA::ULong how_many, 
		   counterSeq_out theCounters);
	
	   void destroy();
		
      bool AtEnd();

   private :

      NamedCounterFactoryImpl::CounterContainer &m_counters;
      NamedCounterFactoryImpl::CounterContainer::list_iterator m_current;
};


#endif // NAMED_COUNTER_ITERATOR_IMPL_INCLUDED__